' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2006                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : K.Yakushinji
'
'  : 2006/12/01 
' -----------------------------------------------------------------
Imports FVDATASLib
Imports FVXCOMDISPLAYEXLib

Public Class frmMain

    'INIt@Cǂݍ
    Declare Function GetPrivateProfileString Lib "KERNEL32.DLL" Alias "GetPrivateProfileStringA" ( _
     ByVal lpAppName As String, _
     ByVal lpKeyName As String, _
     ByVal lpDefault As String, _
     ByVal lpReturnedString As String, _
     ByVal nSize As Integer, _
     ByVal lpFileName As String) As Integer

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'rfIݒt@CitpXj
    Private m_strVideoConfFilePath As String

    't[ǂ
    Private m_boolIsFreerun As Boolean
    Private m_boolexitFlag As Boolean

    'WOIő喇
    Const MAX_WOI = 16

    'WOI FvxDisplay}`IDƕID
    Private m_intDispExWoiWndID(0 To MAX_WOI - 1) As Integer
    Private m_intDispExWoiNoID(0 To MAX_WOI - 1) As Integer

    'WOIWindow̕ύXtO
    Private m_intFlagChangeWoiWnd As Integer

    'FvxDisplayEx TEXTI[oCԍ
    Const TEXT_OVR_NO = 1

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'rfIfoCX̃I[vԕێϐ̏
        m_blnVideoOpened = False
        btnGrab.Enabled = False
        btnFreerun.Enabled = False
        radioNormal.Enabled = False
        radioChunk.Enabled = False
        chkSetWOIWindow.Enabled = False
        gridWoiWindow.Enabled = False

        'gp̊mF
        If My.Forms.frmLicence.ShowDialog() <> Windows.Forms.DialogResult.Yes Then
            End
        End If

        'rfIfoCXI
        setVideoConfFile()

    End Sub

    'rfIݒt@CđI
    Private Sub setVideoConfFile()

        Dim intCaptureType As Integer  'Lv`{[h̃^Cv
        Dim intCaptureNum As Integer   'Lv`{[h̖
        Dim i As Integer, j As Integer
        Dim bStatus As Boolean

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()

        If m_blnVideoOpened = True Then
            'rfIfoCXI[vĂꍇ͈UN[Y܂
            AxFvxVideo1.CloseDevice()
            m_blnVideoOpened = False
        End If

        'rfIݒt@C̑I
        m_strVideoConfFilePath = ""
        If frmSelectVideoConfFile.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_strVideoConfFilePath = frmSelectVideoConfFile.strVideoConfFilePath
        End If

        Try

            If m_strVideoConfFilePath.Length <> 0 Then

                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath
                'foCXI[v
                AxFvxVideo1.OpenDevice()

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImegeTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂ
                'i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                '捞
                AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())

                'rfIfoCX̏ԂL
                m_blnVideoOpened = True
                btnGrab.Enabled = True
                btnFreerun.Enabled = True

                'Lv`{[h擾
                AxFvxVideo1.GetCaptureNum(intCaptureNum)
                'Lv`{[h^Cv擾
                AxFvxVideo1.GetCaptureType(intCaptureType)

                'gK[h
                cmbTrigger.Items.Clear()
                cmbTrigger.Items.Add("m[}")
                cmbTrigger.Items.Add("gK(SW)")
                If intCaptureType >= 2 Then                'RICE(CaptureType=1)͊OgKgps
                    cmbTrigger.Items.Add("OgK(Ext)")
                End If
                cmbTrigger.SelectedIndex = 0

                'I
                AxFvxVideo1.GetExposureTime(i)
                trcExposure.Value = i / 1000
                txtExposure.Text = i / 1000
                txtExposure.Enabled = True
                trcExposure.Enabled = True


                'WOIgpł邩ǂmFAgpłGUI֘Ȁ
                radioNormal.Checked = True
                Dim lngRes As Long
                Dim strBuff As New String(" ", 256)
                lngRes = GetPrivateProfileString("CameraInfo", "WoiUsable", "FALSE", strBuff, strBuff.Length, AxFvxVideo1.VideoConfFile)

                If InStr(strBuff.ToString, "TRUE") > 0 Then   'WOIgpłꍇ
                    'WOI֘A
                    bStatus = fnInitWoiWindow()
                    radioNormal.Enabled = True
                    radioChunk.Enabled = True
                    chkSetWOIWindow.Enabled = True
                    gridWoiWindow.Enabled = True
                Else                                'WOIgpłȂꍇ
                    radioNormal.Enabled = False
                    radioChunk.Enabled = False
                    chkSetWOIWindow.Enabled = False
                    gridWoiWindow.Enabled = False
                End If

            End If

        Catch

            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")

        Finally

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        End Try

    End Sub

    'Lv`I[vALv`ɐݒ肳ĂWOIEBhE
    'FvxDisplayExсAXgr[ɐݒ肷
    Private Function fnInitWoiWindow() As Boolean

        Dim i As Integer
        Dim pRect As New FvRectangle
        Dim pPos As New FvPoint
        Dim bEnable As Boolean
        Dim strEnable As String
        Dim obItem As DataGridViewRow

        'FvxDisplayExɊւ鏉ݒ
        AxFvxDisplayEx1.RoiSetFigureMax(DISPLAYEX_ROI_FIGURE_TYPE.DISPLAYEX_ROI_RECTANGLE, MAX_WOI)      '`ݒMAX_WOI(16)܂
        AxFvxDisplayEx1.RoiChangeNewFigType(DISPLAYEX_ROI_FIGURE_TYPE.DISPLAYEX_ROI_RECTANGLE)           '}`쐬͋`̂
        AxFvxDisplayEx1.RoiErasable = False                                                              '}`̍폜͂łȂ
        AxFvxDisplayEx1.FontAlign = DISPLAYEX_FONT_ALIGN.DISPLAYEX_FontTopLeft                           '̌_͍
        AxFvxDisplayEx1.FontColor = Color.Red                                                            'F͐
        AxFvxDisplayEx1.SetOverlayEnable(TEXT_OVR_NO, False)                   'I[oCPDisableɐݒ

        'Xg̐ݒ
        gridWoiWindow.RowCount = MAX_WOI + 1
        gridWoiWindow.MultiSelect = False
        gridWoiWindow.AllowUserToAddRows = False
        'WOI
        For i = 0 To MAX_WOI - 1
            'ݐݒ肳ĂWOIEBhE擾
            AxFvxVideo1.GetWoiWindow(i, pRect)
            AxFvxVideo1.GetWoiEnable(i, bEnable)

            '`ݒ
            m_intDispExWoiWndID(i) = AxFvxDisplayEx1.RoiCreateFigure(pRect)

            'EBhEԍݒ
            pPos.x = pRect.xs + 5
            pPos.y = pRect.ys + 5
            m_intDispExWoiNoID(i) = AxFvxDisplayEx1.DrawText(TEXT_OVR_NO, pPos, i.ToString)

            'Xgr[ɓo^
            If True = bEnable Then
                strEnable = "Enable"
            Else
                strEnable = "Disable"
            End If

            obItem = gridWoiWindow.Rows(i)
            obItem.Cells(0).Value = bEnable
            obItem.Cells(1).Value = i
            obItem.Cells(2).Value = pRect.xs
            obItem.Cells(3).Value = pRect.ys
            obItem.Cells(4).Value = pRect.xe
            obItem.Cells(5).Value = pRect.ye
            obItem.Cells(6).Value = strEnable

        Next i
        fnInitWoiWindow = True

    End Function

    'J荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        Try
            Dim dblTime As Double

            AxFvxPerformanceCounter1.StartCount()   'ԑJn
            '捞
            If radioNormal.Checked Then
                AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
            Else
                AxFvxVideo1.GrabSync(AxFvxImageWOI.GetOcx())
            End If
            AxFvxPerformanceCounter1.StopCount(dblTime)    'ԑI

            '荞񂾉摜ʂɕ\
            If radioNormal.Checked Then
                AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            Else
                AxFvxDisplayEx1.DrawImage(AxFvxImageWOI.GetOcx())
            End If

            txtGrabTime.Text = dblTime.ToString("0.00ms")

        Catch

            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("捞G[ " + GetFvxVideoErrMsg(intErr), vbExclamation, "G[")

        End Try

    End Sub

    't[JnE~
    Private Sub btnFreerun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreerun.Click

        If m_boolIsFreerun Then
            Timer1.Enabled = False
            fnChangeButtonEnableFreerun(True)
            btnFreerun.Text = "Freerun"
        Else
            Timer1.Interval = 100
            Timer1.Start()
            fnChangeButtonEnableFreerun(False)
            btnFreerun.Text = "Stop"
        End If

        m_boolIsFreerun = Not m_boolIsFreerun
        Application.DoEvents()

    End Sub

    't[
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim dblTime As Double

        Timer1.Stop()

        Try
            If m_blnVideoOpened Then
                AxFvxPerformanceCounter1.StartCount()
                '捞
                If radioNormal.Checked Then
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Else
                    AxFvxVideo1.GrabSync(AxFvxImageWOI.GetOcx())
                End If
                AxFvxPerformanceCounter1.StopCount(dblTime)
            End If

            Timer1.Enabled = True
        Catch

            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MessageBox.Show("捞G[ " + GetFvxVideoErrMsg(intErr), "G[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Timer1.Enabled = False
            btnFreerun.Text = "Freerun"
            m_boolIsFreerun = False

        Finally

            '摜\
            If radioNormal.Checked Then
                AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            Else
                AxFvxDisplayEx1.DrawImage(AxFvxImageWOI.GetOcx())
            End If
            txtGrabTime.Text = dblTime.ToString("0.00ms")

        End Try

    End Sub

    't[͑̐ݒ肪łȂ悤ɂ
    Private Sub fnChangeButtonEnableFreerun(ByVal bEnable As Boolean)
        btnGrab.Enabled = bEnable
        radioNormal.Enabled = bEnable
        radioChunk.Enabled = bEnable
        chkSetWOIWindow.Enabled = bEnable
        btnResetVideoConfFile.Enabled = bEnable
    End Sub

    'gK[h
    Private Sub cmbTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTrigger.SelectedIndexChanged

        Try
            If m_blnVideoOpened Then
                AxFvxVideo1.SetTrigger(cmbTrigger.SelectedIndex)
            End If
        Catch
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'I
    Private Sub trcExposure_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcExposure.Scroll

        Try
            txtExposure.Text = trcExposure.Value
            If m_blnVideoOpened Then
                AxFvxVideo1.SetExposureTime(trcExposure.Value * 1000)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'WOI[h̕ύX
    Private Sub radioNormal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioNormal.CheckedChanged

        'JʐM
        fnCommCamera(True)

        AxFvxVideo1.SetWoiMode(FVXCOMVIDEOLib.FVX_VIDEO_WOI_MODE.videoWoiNormal)     'm[}
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        'JʐM
        fnCommCamera(False)

    End Sub

    'WOI[h̕ύX
    Private Sub radioChunk_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioChunk.CheckedChanged

        'JʐM
        fnCommCamera(True)

        AxFvxVideo1.SetWoiMode( FVXCOMVIDEOLib.FVX_VIDEO_WOI_MODE.videoWoiChunk)      '`N
        AxFvxVideo1.ChangeImageSize(AxFvxImageWOI.GetOcx())
        
        'JʐM
        fnCommCamera(False)

    End Sub

    'uJʐMv\
    Private Sub fnCommCamera(ByVal bComm As Boolean)

        If bComm = True Then
            lbComm.Text = "JʐM"
        Else
            lbComm.Text = ""
        End If

        Application.DoEvents()

    End Sub

    'WOIEBhEݒ
    Private Sub chkSetWOIWindow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkSetWOIWindow.CheckedChanged

        If chkSetWOIWindow.Checked = False Then
            'ݒ芮
            AxFvxDisplayEx1.RoiMode = DISPLAYEX_ROI_MODE.DISPLAYEX_ROIDisable
            AxFvxDisplayEx1.SetOverlayEnable(TEXT_OVR_NO, False)

            'WOIEBhE̐ݒ
            Dim i As Long
            Dim pRect As New FvRectangle
            If 0 <> m_intFlagChangeWoiWnd Then
                'tO`FbNĕύX̂EBhÊ݂ݒ肷
                For i = 0 To MAX_WOI - 1
                    If 0 < (m_intFlagChangeWoiWnd And (2 ^ i)) Then
                        AxFvxDisplayEx1.RoiGetFigure(m_intDispExWoiWndID(i), pRect)
                        fnChangeWoiWindow(i, pRect)
                    End If
                Next i
            End If

            AxFvxVideo1.ChangeImageSize(AxFvxImageWOI.GetOcx())

            '{^悤ɂ
            fnChangeButtonEnableWOI(True)

        Else
            '{^Ȃ悤ɂ
            fnChangeButtonEnableWOI(False)
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            AxFvxDisplayEx1.RoiMode = DISPLAYEX_ROI_MODE.DISPLAYEX_ROIEnable
            AxFvxDisplayEx1.SetOverlayEnable(TEXT_OVR_NO, True)
            m_intFlagChangeWoiWnd = 0
        End If

    End Sub

    'WOIEBhE̕ύX
    Private Sub fnChangeWoiWindow(ByVal lngWndNo As Long, ByVal pRect As FvRectangle)

        'JʐM
        fnCommCamera(True)

        Try
            'WOIEBhEݒ
            AxFvxVideo1.SetWoiWindow(lngWndNo, pRect)
        Catch

            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("SetWoiWindow Error : " + intErr.ToString + ", WndNo=" + lngWndNo.ToString)

        End Try

        'JʐM
        fnCommCamera(False)

    End Sub

    'WOIEBhEݒ蒆WOIEBhEݒ肪łȂ悤ɂ
    Private Sub fnChangeButtonEnableWOI(ByVal bEnable As Boolean)
        btnGrab.Enabled = bEnable
        btnFreerun.Enabled = bEnable
        cmbTrigger.Enabled = bEnable
        trcExposure.Enabled = bEnable
        txtExposure.Enabled = bEnable
        radioNormal.Enabled = bEnable
        radioChunk.Enabled = bEnable
        btnResetVideoConfFile.Enabled = bEnable
        btnSaveImage.Enabled = bEnable
        gridWoiWindow.Columns(0).ReadOnly = bEnable
    End Sub

    'ROI}`̈ړ
    Private Sub AxFvxDisplayEx1_RoiMouseMove(ByVal sender As Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_RoiMouseMoveEvent) Handles AxFvxDisplayEx1.RoiMouseMove
        Dim pRect As New FvRectangle
        Dim nNo As Long
        Dim pPos As New FvPoint

        '}`IDWOI WindowԍZo
        nNo = fnGetWndIDtoNO(e.nFigID)

        '}`̈ʒuZo
        AxFvxDisplayEx1.RoiGetFigure(e.nFigID, pRect)

        '}`ԍ̈ʒuړ
        pPos.x = pRect.xs + 5
        pPos.y = pRect.ys + 5
        AxFvxDisplayEx1.UpdateText(m_intDispExWoiNoID(nNo), pPos, nNo.ToString)

        'Xgr[̍XV
        gridWoiWindow.Rows(nNo).Cells(2).Value = pRect.xs
        gridWoiWindow.Rows(nNo).Cells(3).Value = pRect.ys
        gridWoiWindow.Rows(nNo).Cells(4).Value = pRect.xe
        gridWoiWindow.Rows(nNo).Cells(5).Value = pRect.ye
    End Sub

    'ROI}`̈ړi}EXAbvj
    Private Sub AxFvxDisplayEx1_RoiMouseUp(ByVal sender As Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_RoiMouseUpEvent) Handles AxFvxDisplayEx1.RoiMouseUp

        Dim pRect As New FvRectangle
        Dim nNo As Integer
        Dim pPos As New FvPoint

        '}`IDWOI WindowԍZo
        nNo = fnGetWndIDtoNO(e.nFigID)

        '}`̈ʒuZo
        AxFvxDisplayEx1.RoiGetFigure(e.nFigID, pRect)

        '}`̈ʒuATCYWOIݒ̐ɈvȂꍇ邽߁AŏC
        fnCorrectWindowSize(pRect)
        AxFvxDisplayEx1.RoiUpdateFigure(e.nFigID, pRect)

        '}`ԍ̈ʒuړ
        pPos.x = pRect.xs + 5
        pPos.y = pRect.ys + 5
        AxFvxDisplayEx1.UpdateText(m_intDispExWoiNoID(nNo), pPos, nNo.ToString)

        'Xgr[̍XV
        gridWoiWindow.Rows(nNo).Cells(2).Value = pRect.xs
        gridWoiWindow.Rows(nNo).Cells(3).Value = pRect.ys
        gridWoiWindow.Rows(nNo).Cells(4).Value = pRect.xe
        gridWoiWindow.Rows(nNo).Cells(5).Value = pRect.ye

        'WOIEBhEʒuύXꂽƂtOɎc
        m_intFlagChangeWoiWnd = m_intFlagChangeWoiWnd Or (2 ^ nNo)

    End Sub

    'FvxDisplayEx1̐}`IDAEBhEԍ擾
    Private Function fnGetWndIDtoNO(ByVal intID As Integer) As Integer
        Dim i As Long
        For i = 0 To MAX_WOI - 1
            If m_intDispExWoiWndID(i) = intID Then
                Exit For
            End If
        Next i
        fnGetWndIDtoNO = i
    End Function

    'WOĨEBhETCYɈȂ悤ɁA`̈ʒuC
    Private Sub fnCorrectWindowSize(ByVal pRect As FvRectangle)

        Dim tmp As Double

        '召֌W
        If pRect.xs > pRect.xe Then
            tmp = pRect.xs
            pRect.xs = pRect.xe
            pRect.xe = tmp
        End If
        If pRect.ys > pRect.ye Then
            tmp = pRect.ys
            pRect.ys = pRect.ye
            pRect.ye = tmp
        End If

        'Xn_ 32̔{
        pRect.xs = CLng(pRect.xs / 32) * 32
        'Yn_ 2̔{
        pRect.ys = CLng(pRect.ys / 2) * 2

        'TCY 64ȏ32̔{
        If (pRect.xe - pRect.xs + 1) < 64 Then
            pRect.xe = pRect.xs + 64 - 1
        Else
            pRect.xe = CLng(pRect.xe / 32) * 32 - 1
        End If

        'cTCY 2̔{
        pRect.ye = CLng(pRect.ye / 2) * 2 - 1

    End Sub

    'Xgr[̃ACeNbN
    Private Sub gridWoiWindow_RowEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles gridWoiWindow.RowEnter
        If chkSetWOIWindow.Checked Then
            AxFvxDisplayEx1.RoiChangeActiveFigure(m_intDispExWoiWndID(e.RowIndex))
        End If
    End Sub

    'Xgr[̃`FbN{bNX
    Private Sub gridWoiWindow_CurrentCellDirtyStateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles gridWoiWindow.CurrentCellDirtyStateChanged

        Dim i As Integer

        gridWoiWindow.CommitEdit(DataGridViewDataErrorContexts.Commit)
        i = gridWoiWindow.CurrentCellAddress.Y


        If chkSetWOIWindow.Checked Then
            If gridWoiWindow.Rows(i).Cells(0).Value = True Then
                gridWoiWindow.Rows(i).Cells(6).Value = "Enable"

                'WOIEBhEEnable̐ݒ
                fnChangeWoiWindowEnable(i, True)

            Else
                gridWoiWindow.Rows(i).Cells(6).Value = "Disable"

                'WOIEBhEEnable̐ݒ
                fnChangeWoiWindowEnable(i, False)

            End If

        End If

    End Sub

    'WOIEBhEEnable̕ύX
    Private Sub fnChangeWoiWindowEnable(ByVal intWndNo As Integer, ByVal bEnable As Boolean)
        'JʐM
        fnCommCamera(True)

        'WOIEBhEEnableݒ
        AxFvxVideo1.SetWoiEnable(intWndNo, bEnable)

        'JʐM
        fnCommCamera(False)
    End Sub

    'rfIݒt@CĐݒ
    Private Sub btnResetVideoConfFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetVideoConfFile.Click

        't[Ȃ΁A~B
        If m_boolIsFreerun Then
            Timer1.Enabled = False
            btnFreerun.Text = "Freerun"
            m_boolIsFreerun = False
        End If

        'rfIfoCX̑I
        setVideoConfFile()

    End Sub

    '\摜ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = Application.StartupPath
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.FileName = ""
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                If radioNormal.Checked Then
                    AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
                Else
                    AxFvxFileAccess1.SaveBitmap(AxFvxImageWOI.GetOcx())
                End If
            Catch
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" + intErr.ToString() + ")", vbExclamation, "ۑs")
            End Try
        End If

    End Sub

    'AScope\؂ւ
    Private Sub chkAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAScope.CheckedChanged
        If chkAScope.Checked Then
            AxFvxDisplayEx1.AScopeMode = DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
        Else
            AxFvxDisplayEx1.AScopeMode = DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
        End If
    End Sub

    '\{minus
    Private Sub btnDispMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispMinus.Click
        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification - 0.5
        If AxFvxDisplayEx1.Magnification <= 0.5 Then
            btnDispMinus.Enabled = False
        Else
            btnDispMinus.Enabled = True
        End If
        btnDispPlus.Enabled = True
    End Sub

    '\{plus
    Private Sub btnDispPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPlus.Click
        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification + 0.5
        If AxFvxDisplayEx1.Magnification > 10.0# Then
            btnDispPlus.Enabled = False
        Else
            btnDispPlus.Enabled = True
        End If
        btnDispMinus.Enabled = True
    End Sub

    '{\
    Private Sub btnDisp1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisp1.Click
        AxFvxDisplayEx1.Magnification = 1

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True
    End Sub

    'tʕ\
    Private Sub btnDispFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispFull.Click

        Dim dblScaleX As Double
        Dim dblScaleY As Double

        dblScaleX = AxFvxDisplayEx1.Width / AxFvxImage1.ImageWidth
        dblScaleY = AxFvxDisplayEx1.Height / AxFvxImage1.ImageHeight

        If dblScaleX < dblScaleY Then
            AxFvxDisplayEx1.Magnification = dblScaleX
        Else
            AxFvxDisplayEx1.Magnification = dblScaleY
        End If

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'FvxVideoG[bZ[W擾
    Private Function GetFvxVideoErrMsg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 6001
                GetFvxVideoErrMsg = "\ȂG[łB"
            Case 6002
                GetFvxVideoErrMsg = "T|[gĂ܂B"
            Case 6005
                GetFvxVideoErrMsg = "p[^słB"
            Case 6010
                GetFvxVideoErrMsg = "̊mۂɎs܂B"
            Case 6015
                GetFvxVideoErrMsg = "DLLt@C݂܂B"
            Case 6020
                GetFvxVideoErrMsg = "foCX̃I[vɎs܂B"
            Case 6021
                GetFvxVideoErrMsg = "ɃI[vĂ܂B"
            Case 6030
                GetFvxVideoErrMsg = "Lv`I[vĂ܂B"
            Case 6031
                GetFvxVideoErrMsg = "Lv`{[h܂B"
            Case 6032
                GetFvxVideoErrMsg = "foCXIDsłB"
            Case 6037
                GetFvxVideoErrMsg = "GrabASynĉߏs܂B"
            Case 6040
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case 6041
                GetFvxVideoErrMsg = "^CAEg܂B"
            Case 6042
                GetFvxVideoErrMsg = "摜f[^słB"
            Case 6043
                GetFvxVideoErrMsg = "摜͂Ɏs܂B"
            Case 6044
                GetFvxVideoErrMsg = "Xe[^X`FbNɎs܂B"
            Case 6045
                GetFvxVideoErrMsg = "ݒ肵摜TCYvĂȂAWOIEBhEPݒ肳Ă܂B"
            Case 6046
                GetFvxVideoErrMsg = "摜̃bNɎs܂B"
            Case 6047
                GetFvxVideoErrMsg = "摜̃AbNɎs܂B"
            Case 6048
                GetFvxVideoErrMsg = "nhsłB"
            Case 6052
                GetFvxVideoErrMsg = "[h̕ύXɎs܂B"
            Case 6053
                GetFvxVideoErrMsg = "[h̎擾Ɏs܂B"
            Case 6054
                GetFvxVideoErrMsg = "Lv`TCY̕ύXɎs܂B"
            Case 6055
                GetFvxVideoErrMsg = "摜TCY擾Ɏs܂B"
            Case 6056
                GetFvxVideoErrMsg = "Lv`ItZbgݒɎs܂B"
            Case 6058
                GetFvxVideoErrMsg = "rfIItZbg̐ݒɎs܂B"
            Case 6060
                GetFvxVideoErrMsg = "IԂ̐ݒɎs܂B"
            Case 6061
                GetFvxVideoErrMsg = "IԂ̎擾Ɏs܂B"
            Case 6062
                GetFvxVideoErrMsg = "^CAEg̕ύXɎs܂B"
            Case 6063
                GetFvxVideoErrMsg = "^CAEg擾Ɏs܂B"
            Case 6066
                GetFvxVideoErrMsg = "2lݒɎs܂B"
            Case 6074
                GetFvxVideoErrMsg = "gK[h̕ύXɎs܂B"
            Case 6080
                GetFvxVideoErrMsg = "rfIݒt@C܂B"
            Case 6081
                GetFvxVideoErrMsg = "rfIݒt@CpXݒ肳Ă܂B"
            Case 6085
                GetFvxVideoErrMsg = "JR}ht@C܂B"
            Case 6100
                GetFvxVideoErrMsg = "SIOR}hgpł܂B"
            Case 6101
                GetFvxVideoErrMsg = "SIOR}h܂B"
            Case 6102
                GetFvxVideoErrMsg = "SIO^CAEg܂BJڑĂ邱ƂmFĂB"
            Case 6150
                GetFvxVideoErrMsg = "[Jobt@ȏ̃TCYw肵Ă܂B"
            Case 6200
                GetFvxVideoErrMsg = "JڑĂȂAdĂ܂B"
            Case 6201
                GetFvxVideoErrMsg = "J̏Ɏs܂B"
            Case 6202
                GetFvxVideoErrMsg = "JtbVɎs܂B"
            Case 6203
                GetFvxVideoErrMsg = "JZ[uɎs܂B"
            Case 6204
                GetFvxVideoErrMsg = "J[hɎs܂B"
            Case 6210
                GetFvxVideoErrMsg = "BitWidthݒɎs܂B"
            Case 6211
                GetFvxVideoErrMsg = "Bit擾Ɏs܂B"
            Case 6212
                GetFvxVideoErrMsg = "CC̐ݒɎs܂B"
            Case 6213
                GetFvxVideoErrMsg = "CC̎擾Ɏs܂B"
            Case 6214
                GetFvxVideoErrMsg = "SIO[hݒɎs܂B"
            Case 6216
                GetFvxVideoErrMsg = "SIOp[^̐ݒɎs܂B"
            Case 6217
                GetFvxVideoErrMsg = "SIOp[^̎擾Ɏs܂B"
            Case 6218
                GetFvxVideoErrMsg = "WOIEBhE̐ݒɎs܂B"
            Case 6220
                GetFvxVideoErrMsg = "WOI Enable̐ݒɎs܂B"
            Case 6222
                GetFvxVideoErrMsg = "WOI[h̐ݒɎs܂B"
            Case 6221
                GetFvxVideoErrMsg = "WOI Enable̎擾Ɏs܂B"
            Case 6223
                GetFvxVideoErrMsg = "WOI[h̎擾Ɏs܂B "
            Case 6360
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case Else
                GetFvxVideoErrMsg = "sȃG["
        End Select

    End Function
End Class
